<template>
    <div class="search" :class="loaded ? '' : 'search--init_animation_state'">

        <google-map
            :place-id="placeId"
            :zoom="map_zoom"
            ></google-map>

        <div class="search__header container">
            <div class="search__title">
                <div class="medium">Поиск</div>адресов
            </div>
            <div class="search__cancel">
                <transition name="fade" mode="out-in">
                    <div
                        v-if="showCancelButton" 
                        @click="cancel"
                        class="button button--red">Отмена</div>
                </transition>
               
            </div>
        </div>

        <input @focus="setFocus(true)" @blur="setFocus(false)"
            class="search__input container container--remove_top_bottom"
            placeholder="Введите адрес"
            v-model="request"
            type="text">

        <div
            class="search__focus"
            :class="loaderClasses"
        ></div>

        <div class="search__results container">
            <div v-if="status.visible" class="search__status">
                {{status.msg}}
            </div>
            <template v-if="isValidResults">
                <transition-group name="list">
                    <div class="search__item"
                        v-for="(item, index) in results.predictions"
                        :key="index">

                        <div class="search__address">
                            {{item.description}}
                        </div>
                        <div class="search__choice">
                            <div @click="choose(item)" class="button button--green">Выбрать</div>
                        </div>
                    </div>
                </transition-group>
            </template>
        </div>
        <div class="search__footer">
            <div class="search__special">
                Специально для
                <img src="/assets/img/1933391.png" alt="" class="search__logo">
            </div>
        </div>
    </div>
</template>

<script>
import { from} from 'rxjs'
import { distinctUntilChanged, debounceTime, pluck, tap, map, filter, switchMap, take } from 'rxjs/operators';
import axios from 'axios'

import Vue from "vue"

const statuses = {
    OK : '', 
    ZERO_RESULTS : 'Ничего не найдено', 
    OVER_QUERY_LIMIT : 'Превышен лимит', 
    INIT : 'Начните поиск вводом более 3х символов',
}

const cancelState = {

}

function fetch(term){
    return from(axios.get('/api', {
        params: {
            query: term
        }
    }))
}

function format(data){
    return data.data
}

export default {
    data(){
        return {
            focus: false,
            request: "",
            loaded: false,
            choosedRespoonce: "",
            loading: false,
            placeId: '',
            map_zoom: 'world',
            status:{
                visible: true,
                msg: statuses.INIT
            }
        }
    },
    mounted(){
        setTimeout(()=> this.loaded = true, 100)
    },
    methods:{
        setFocus(value){
            this.focus = value
        },
        cancel(){
            this.request = ""
            this.loading = false
            this.results = undefined
            this.placeId = ''
            this.choosedRespoonce = ''
            
            this.map_zoom = 'world'
        },
        choose(item){
            this.request = item.description
            this.placeId = item.place_id

            this.map_zoom = 'address'

            this.choosedRespoonce = this.request
            this.results = undefined
            
            this.status.msg = statuses.INIT
            this.status.visible = true
        }
    },
    subscriptions: function() {
        return {
            results: this.$watchAsObservable("request").pipe(
                pluck('newValue'),
                filter(text => text.length > 3 && text != this.choosedRespoonce),
                debounceTime(500),
                distinctUntilChanged(),
                tap(() => this.loading = true),
                switchMap(fetch),
                tap(() => this.loading = false),
                map(format),
                tap((data) => {
                    this.status.msg = statuses[data.status]
                    this.status.visible = data.status != 'OK'
                }),
            )
        }
    },
    computed:{
        showCancelButton(){
            return this.request.length > 0
        },
        loaderClasses(){
            return {
                'search__focus--onfocus' : this.focus,
                'search__loader' : this.loading
            }
        },
        isValidResults(){
            return typeof this.results == 'object'
        }
    }
}
</script>
